#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

#ifndef _MATINGSELECTION_H_
#define _MATINGSELECTION_H_

#include "Individual.h"
#include "Parameter.h"
#include "Population.h"
#include "Archive.h"

//============================================
//	class MatingSelection
//============================================

class Archive;
class Population;
class MatingSelection{
public:
	
	MatingSelection(){};
	//ᥤƥ򤹤ݥ᥽å
	virtual void select(Archive& archive,Population& population) = 0;
};

//============================================
//	class TournamentSelection
//============================================
class TournamentSelection : public MatingSelection{
public:

	TournamentSelection(){};
	//֤콸Ĥ˥ȡʥ
	void select(Archive& archive,Population& population);

};

#endif //_MATINGSELECTION_H_
