#ifndef _PARAMETER_H_
#define _PARAMETER_H_

#include "../multiobjectiveProblem/Function.h"


class Parameter{
private:
	Parameter();
	Function *func;	//о
	int numObjective;	//Ūؿο
	int numDesign;	//߷ѿο
	int populationSize;	//콸ĥ
	int geneLength;	//Ĺ
	int designLength;	//߷ѿΥӥåĹ
	int numCrossover;//
	int maxGeneration;//λ
    int fInitialPopulation;//Υե 0: 1:ե(design_variable.ini)
	double mutationRate;//ѰΨ
	double crossoverRate;//Ψ

	
public:
	
	static Parameter& getInstance();
	
	Function* getfunc(){
		return func;
	}

	int getObjectiveNum(){
		return numObjective;
	}
	
	int getPopulationSize(){
		return populationSize;
	}
	
	int getGeneLength(){
		return geneLength;
	}
	
	int getCrossOverNum(){
		return numCrossover;
	}
	
	int getMaxGeneration(){
		return maxGeneration;
	}
	
	double getMutationRate(){
		return mutationRate;
	}
	
	double getCrossOverRate(){
		return crossoverRate;
	}

    int getFInitialPopulation(){
	    return fInitialPopulation;
    }

};
#endif //_PARAMETER_H_

